<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/aho-corasick-0.7.18/src/error.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>error.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../aho_corasick/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../aho_corasick/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../aho_corasick/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">std::error</span>;
<span class="kw">use</span> <span class="ident">std::fmt</span>;
<span class="kw">use</span> <span class="ident">std::result</span>;

<span class="kw">pub</span> <span class="kw">type</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">result::Result</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">Error</span><span class="op">&gt;</span>;

<span class="doccomment">/// An error that occurred during the construction of an Aho-Corasick</span>
<span class="doccomment">/// automaton.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Error</span> {
    <span class="ident">kind</span>: <span class="ident">ErrorKind</span>,
}

<span class="doccomment">/// The kind of error that occurred.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">ErrorKind</span> {
    <span class="doccomment">/// An error that occurs when constructing an automaton would require the</span>
    <span class="doccomment">/// use of a state ID that overflows the chosen state ID representation.</span>
    <span class="doccomment">/// For example, if one is using `u8` for state IDs and builds a DFA with</span>
    <span class="doccomment">/// 257 states, then the last state&#39;s ID will be `256` which cannot be</span>
    <span class="doccomment">/// represented with `u8`.</span>
    <span class="ident">StateIDOverflow</span> {
        <span class="doccomment">/// The maximum possible state ID.</span>
        <span class="ident">max</span>: <span class="ident">usize</span>,
    },
    <span class="doccomment">/// An error that occurs when premultiplication of state IDs is requested</span>
    <span class="doccomment">/// when constructing an Aho-Corasick DFA, but doing so would overflow the</span>
    <span class="doccomment">/// chosen state ID representation.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// When `max == requested_max`, then the state ID would overflow `usize`.</span>
    <span class="ident">PremultiplyOverflow</span> {
        <span class="doccomment">/// The maximum possible state id.</span>
        <span class="ident">max</span>: <span class="ident">usize</span>,
        <span class="doccomment">/// The maximum ID required by premultiplication.</span>
        <span class="ident">requested_max</span>: <span class="ident">usize</span>,
    },
}

<span class="kw">impl</span> <span class="ident">Error</span> {
    <span class="doccomment">/// Return the kind of this error.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">kind</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span><span class="ident">ErrorKind</span> {
        <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">kind</span>
    }

    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">state_id_overflow</span>(<span class="ident">max</span>: <span class="ident">usize</span>) -&gt; <span class="ident">Error</span> {
        <span class="ident">Error</span> { <span class="ident">kind</span>: <span class="ident">ErrorKind::StateIDOverflow</span> { <span class="ident">max</span> } }
    }

    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">premultiply_overflow</span>(
        <span class="ident">max</span>: <span class="ident">usize</span>,
        <span class="ident">requested_max</span>: <span class="ident">usize</span>,
    ) -&gt; <span class="ident">Error</span> {
        <span class="ident">Error</span> { <span class="ident">kind</span>: <span class="ident">ErrorKind::PremultiplyOverflow</span> { <span class="ident">max</span>, <span class="ident">requested_max</span> } }
    }
}

<span class="kw">impl</span> <span class="ident">error::Error</span> <span class="kw">for</span> <span class="ident">Error</span> {
    <span class="kw">fn</span> <span class="ident">description</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span><span class="ident">str</span> {
        <span class="kw">match</span> <span class="self">self</span>.<span class="ident">kind</span> {
            <span class="ident">ErrorKind::StateIDOverflow</span> { .. } =&gt; {
                <span class="string">&quot;state id representation too small&quot;</span>
            }
            <span class="ident">ErrorKind::PremultiplyOverflow</span> { .. } =&gt; {
                <span class="string">&quot;state id representation too small for premultiplication&quot;</span>
            }
        }
    }
}

<span class="kw">impl</span> <span class="ident">fmt::Display</span> <span class="kw">for</span> <span class="ident">Error</span> {
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;mut</span> <span class="ident">fmt::Formatter</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>) -&gt; <span class="ident">fmt::Result</span> {
        <span class="kw">match</span> <span class="self">self</span>.<span class="ident">kind</span> {
            <span class="ident">ErrorKind::StateIDOverflow</span> { <span class="ident">max</span> } =&gt; <span class="macro">write!</span>(
                <span class="ident">f</span>,
                <span class="string">&quot;building the automaton failed because it required \
                 building more states that can be identified, where the \
                 maximum ID for the chosen representation is {}&quot;</span>,
                <span class="ident">max</span>,
            ),
            <span class="ident">ErrorKind::PremultiplyOverflow</span> { <span class="ident">max</span>, <span class="ident">requested_max</span> } =&gt; {
                <span class="kw">if</span> <span class="ident">max</span> <span class="op">==</span> <span class="ident">requested_max</span> {
                    <span class="macro">write!</span>(
                        <span class="ident">f</span>,
                        <span class="string">&quot;premultiplication of states requires the ability to \
                         represent a state ID greater than what can fit on \
                         this platform&#39;s usize, which is {}&quot;</span>,
                        <span class="ident">::std::usize::MAX</span>,
                    )
                } <span class="kw">else</span> {
                    <span class="macro">write!</span>(
                        <span class="ident">f</span>,
                        <span class="string">&quot;premultiplication of states requires the ability to \
                         represent at least a state ID of {}, but the chosen \
                         representation only permits a maximum state ID of {}&quot;</span>,
                        <span class="ident">requested_max</span>, <span class="ident">max</span>,
                    )
                }
            }
        }
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="aho_corasick" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>